% %"Bowed string", hyperbolic stick-slip model:

% (Mostly Pitteroff values used)

%Physical model parameters:
beta = 0.5;%relative bow position on the string (0 = on the bridge, 1 = on the nut). Note that this cannot be chosen freely for the hybrid instrument! It is only used here to calculate the schelling maxima
mu_d=0.3;
mu_s=0.8;
delta=mu_d/mu_s;
%K= ... %string tension
%e= ... %string linear mass density
Zcstring = 0.2;%sqrt(K*e); %kg/s
%!add ZT for torsional impedance (eg: Pitteroff: ZT/Z0=1.6)
%ZT=alpha*Zcstring:
alpha=0.5;%Schelleng: lies between 0.26 and 1.

% for zeta: create steped function from zetamin to zetamax
nzetab = 3;
timevs=linspace(0,runtime,nzetab+1);
timevect_sigs = [0, reshape(ones(2,1)*timevs(2:end),1,2*nzetab)];
zetab_min = 0.2;
zetab_max = 1;
zetab_vect = [timevect_sigs', [reshape(ones(2,1)*linspace(zetab_min,zetab_max,nzetab),1,2*nzetab), 0]'];
zetab_cte = 0.2;
%for the controller:
par2controlmin = zetab_min;
par2controlmax = zetab_max;

%Min and max velocity for a certain bowing force, �based on Schelling diagram
%!however, the min formula is based on a version for beta<<0.5..! not sure
%if the second version is correct..!
% %!todo: re-check formula to calculate FPmin (see Maple .. (?)):
% FPmin = 2.5/pi*vb_cte;%!? 1 mode:0.55/pi ...?%!for 8 modes: 2.5/pi; %!? for 1 mode, I rather found: 69/pi*vb_cte
% FP = 1.5*FPmin;
% %!FPmax can be calculated from "Schelleng's rule" -> eg: Pitteroff1998 ->
% %Schelleng1973. (see 20/2/15 in my notebook)
gammabmin_vect = zetab_vect(:,2)*alpha;%"oscillation threshold" %!zetab_vect(:,2)*(1-delta)*beta*2;%! *2 just empirical
%gammabmin_vect = zetab_vect(:,2)*(1-delta)*beta*(1-beta)*3/2;
Y0t2Zcstring= 0.03;%based on 1st mode: 1/(an(1)*Qn(1)/wn(1));
gammabmax_vect = zetab_vect(:,2)*3*(1-delta)*(1-beta)*beta^2/Y0t2Zcstring; %! hmm strictly speaking this should be *4...
%set odds to start and even to end values:
gammabmin_vect(2:2:end)=0; gammabmax_vect(1:2:end)=0;
gammab_vect = [timevect_sigs' gammabmin_vect+gammabmax_vect];
%vb_vect = [timevect_sigs'  vb_min+ (sawtooth(timevect_sigs/5*2*pi)+1)'/2*(vb_max-vb_min) ];
gammab_cte = 1;
%for the controller:
par1controlmin = 0.2 %!min(gammab_vect(1:end-1,2));
par1controlmax=1 %!max(gammab_vect(:,2));

gammabrampcheck_vect = [[0 1 2]', [-7.5 7.5 -7.5]'];

%this is actually the v0 parameter in the BS model:
PM = 50;%! 15.36%!/max(gammab_vect(:,2)); %!200/1 for zetab_cte = 0.2

%% gammab and zetab envelopes for the attack measurements
%Note: attack evaluation cannot be made relative from runtime, because the attack envelope times have to be respected!
%!timevect_gammab_env1 = [0;0.2;0.5;1.55;1.56]; genvend_time = 1.9;                   nenv1 = length(timevect_gammab_env1);
timevect_gammab_env1 = [0;0.2;0.21;1.3;1.31]; genvend_time = 1.5;                   nenv1 = length(timevect_gammab_env1);
gammab_maxvect_norm = [0, 0.0625, 0.125, 0.25, 0.37, 0.5, 0.6, 0.75, 0.875, 1];     ngammab_maxvect = length(gammab_maxvect_norm);
gammab_env1_a = [0;0;1;1;0];                                                        ngammab_env1_a = length(gammab_env1_a);
%! choose either of both zeta vectors:
%!zetab_vect2 = [0.2;0.6;1];
zetab_vect2 = [0.4;0.8;1.2];
nzetab_vect2 = length(zetab_vect2);

%prepare gammab envelopes vector:
n = nzetab_vect2*ngammab_maxvect;
timevect_gammab_envs_all = [repmat(timevect_gammab_env1,n,1); 0]+ floor(0:1/nenv1:n)'*genvend_time;
n = ngammab_env1_a*ngammab_maxvect;
%Following the Schelling zone (see above for the sustained sound envelopes):
gammab_envs_all = [timevect_gammab_envs_all, [reshape(reshape(gammab_env1_a * gammab_maxvect_norm, n,1) * zetab_vect2'*(3*(1-delta)*(1-beta)*beta^2/Y0t2Zcstring - alpha) ...
    + reshape(gammab_env1_a * gammab_maxvect_norm, n,1) * zetab_vect2'*alpha,nzetab_vect2*n,1); 0] ]; %! hmm strictly speaking this should be *4 for gammab maxima

%prepare zetab envelopes vectors:
n=genvend_time*ngammab_maxvect;
timevect_sigs2_zetab = [0;n-Ts;n;n*2-Ts;n*2;n*3-Ts;n*3];
zetab_envs_all = [timevect_sigs2_zetab, [reshape(ones(1,2)' * zetab_vect2' , nzetab_vect2*2,1) ; 0]];

