% Lip-reed dynamics:

%This is not exactly as Vergez2000 as I use an opening at rest, while
%Vergez uses H=0...
%For that, it's possible to set yth to 0. zeta then controls the offset (?)
%-> the result is not very different though (f0 starts increasing a bit
%earlier)...

% Beating pressure
PM =20; %!set
PM_vect = [[0;30], linspace(10,1000,2)'];
zetal = 0.15; % typicaly between 0.1 and 0.8, but what for a lip-reed..?
% Nondimensional mouth pressure
gammal_cte = 2;%!->4

% for zeta: create sawtooth from 0.1 to 0.6, with 5s period
timevect_sigs = [0,5-Ts,5,10-Ts,10,15-Ts,15,20-Ts,20,25-Ts,25,30-Ts,30];
%minval = 0.1;
%maxval = 0.4;
%zetal_vect = [timevect_sigs'  minval+ (sawtooth(timevect_sigs/5*2*pi)+1)'/2*(maxval-minval) ];
zetal_vect = [timevect_sigs', [0.03;0.03;0.05;0.05;0.07;0.07;0.25;0.25;0.3;0.3;0.35;0.35;0]];
%zetal_vect = [timevect_sigs', [0.4;0.4;0.45;0.45;0.5;0.5;0.55;0.55;0.6;0.6;0.65;0.65;0]];

par2controlmax = 300;
par2controlmin = 140*0.5;

%gammal_vect = [[0;30], linspace(0.34,1,2)'];
gamma_min = 1; gamma_max=5;%lipvalve: gamma_min = 1; gamma_max=7;
gammal_vect = [timevect_sigs'  gamma_min+ (sawtooth(timevect_sigs/5*2*pi)+1)'/2*(gamma_max-gamma_min) ];
par1controlmin = gamma_min; par1controlmax=gamma_max;

%wr_vect
wr_start = 0.5*140*2*pi; wr_stop=4*140*2*pi;
wr_vect = [timevect_sigs'  wr_start+ (sawtooth(timevect_sigs/5*2*pi)+1)'/2*(wr_stop-wr_start) ];

%Qr_vect
Qr_vect = [timevect_sigs', [2;2;3;3;4;4;6;6;2;2;4;4;1]];%![1;1;2;2;3;3;4;4;5;5;6;6;1]

% Reed dynamics
wr = 2*pi*140*0.7; %needs to be low enough as the lip-beating increases the resonance. 0.5 results in almost sinusoidal signal...
%Value of Qr
%Here: J. Saneyoshi, H. Teramura, S. Yoshikawa: Feedback oscilla- tions in reed woodwind and brasswind instrumetns. Acustica 62 (1987) 194-210.
%they propose 5
%In Vergez2000, 2.88 is used. Also, Keefe proposes a "typical range": 2<Qr<3 (D. H. Keefe: Physical Modelling of Wind Instruments. Computer Music Journal 16 (1992) 57-73.)
%Empirical evaluation showed Q=1 = much more damped, but Q=1 to 6 similar
%amplitude progressions (for increasing gamma), and more harmonics for
%higher Q (similar to zeta).
Qr = 3;
%for the hit-state:
%Vergez2000: k2 = 3*k; r2=4*r; but they get additioned with k and r
%respectively...
alpha_k = 4;
alpha_r = 5;
%wr2 = sqrt(alpha_k*k/m) = wr*sqrt(alpha_k)
alpha_wr = sqrt(alpha_k);
%Q2 = wr2/r2 = alpha_wr/alpha_r *wr/r = alpha_wr/alpha_r * Q.
alpha_Qr = alpha_wr/alpha_r;
%Smooth transition zone (see Vergez2000 "xth", although no numerical values given in that paper! this value is empirical!)
yb=1;%1%0; %Dimensionless reed beating position, i.e. =ybd/H, where ybd is either -H (open at rest), 0*H (rest position = collision position) or +H (closed at rest). Vergez2000: yb=0
yth=yb+0.2;% Should be > yb (transition will occur between yth and yb.)
ae=1.5 gives smoother results, so more realistic, but it destabilises the hybrid instrument! % open lip area exponent (see Bromage2010: ae = 1 to 2) -> Vergez2000: =1.

%This code is implemented in the S-function, so that the parameters can be
%controlled + the nonlinear friction and stiffness are included.
%approximated digitized version (Guillemain2005)
qr=1/Qr;
a0a = fs^2/wr^2 + fs*qr/(2*wr);
b1a = 1/a0a;
a1a = (2*fs^2/wr^2 -1)/a0a;
a2a = (fs*qr/(2*wr) - fs^2/wr^2)/a0a;
HRreed_G.num = [0, -b1a];
HRreed_G.den = [1, -a1a, -a2a];
HRreed_G_zm1.num = b1a; % As the pressure measurement occurs 1 sample too late, we erase the 1 sample delay from the reed-complicance-filter. -> not sure if that's the right explanation: it's to cope with the "direct loop"...

%! observe Zt and Zr to check matching phase
% figure,
% load('/Users/kurijnbuys/PhD/Data/Characterising/Measurements/Acoustic impedances/with laser vibrometer/Zt_vibro_pt1-2.mat');
% plotgp(freq_v_vibro_m2b, Zt);
% s2=2j*pi*freq_v_vibro_m2b;
% Zr = 1./(s2.^2 + wr/Qr*s2 + wr^2);
% plotgp(freq_v_vibro_m2b, (Zr.^-1)*exp(-pi*1j),'--k');



%gammal and zetal envelopes for the attack measurements:

timevect_gammal_env1 = [0;0.2;0.5;1.55;1.56]; genvend_time = 1.9; nenv1 = length(timevect_gammal_env1);
%!timevect_gammal_env1 = [0;0.2;0.21;1.3;1.31]; genvend_time = 1.5;   nenv1 = length(timevect_gammal_env1);
gammal_mavvect = [1 1.5 2 2.5 3 3.5 4 4.5 5];                       ngammal_mavvect = length(gammal_mavvect);       %add  a low gamma for precision, like with SR..?
gammal_env = [0;0;1;1;0];                                           ngammal_env = length(gammal_env);
%!choose zeta vect:
zetal_vect_att = [0.03;0.05;0.07];
%zetal_vect_att = [0.09;0.11;0.13];
nzetal_vect2_att = length(zetal_vect_att);

%prepare gammal envelopes vector:
n = nzetal_vect2_att*ngammal_mavvect;
timevect_gammal_envs_all = [repmat(timevect_gammal_env1,n,1); 0]+ floor(0:1/nenv1:n)'*genvend_time;
n = ngammal_env*ngammal_mavvect;
gammal_envs_all = [timevect_gammal_envs_all, [reshape(reshape(gammal_env * gammal_mavvect, n,1) * ones(1,nzetal_vect2_att),nzetal_vect2_att*n,1); 0] ];

%prepare zetal envelopes vectors:
n=genvend_time*ngammal_mavvect;
timevect_sigs2_zetal = [0;n-Ts;n;n*2-Ts;n*2;n*3-Ts;n*3];
zetal_envs_all = [timevect_sigs2_zetal, [reshape(ones(1,2)' * zetal_vect_att' , nzetal_vect2_att*2,1) ; 0]];

