#!/bin/sh

##initializing drivers:

echo
echo
echo '### Mou -  li  -  nette ###...'
echo
echo "-1" >> /proc/sys/kernel/sched_rt_runtime_us
echo '- Initializing NI drivers...'

#! this line has been removed from Simon's original code (by himself):
#modprobe xeno_native

#set appropriate PCI slot, use lspci command:
result=$(echo 'xenomai' | sudo /usr/xenomai/sbin/analogy_config analogy0 analogy_ni_pcimio 0x4,0 2>&1)

if [ $? -eq 234 ]; then
    echo '  (drivers already initialized)'
elif [ $? -eq 0 ]; then
    echo '  (drivers successfully initialized)'
fi

if [ $1 ]; then
  PROJECT_NAME=$1
else
   echo 'Error: pass Simulink project name as argument.'
   exit 1
fi

cd ${PROJECT_NAME}_grt_rtw

if [ ! -d Makefile ]; then
   rm Makefile
fi

if [ ! -f Makefile ]; then
   cp ${PROJECT_NAME}.mk Makefile
#   mv ${PROJECT_NAME}.mk Makefile

echo '- Renaming makefile...'
#MAKEFILE             = ${PROJECT_NAME}.mk
sed -i "s/MAKEFILE             = ${PROJECT_NAME}.mk/MAKEFILE             = Makefile/g" Makefile

echo '- Customizing makefile with analogy stuff...'
##ADDITIONAL_LDFLAGS   = 
#USER_INCLUDES = "-I/usr/xenomai/include"
sed -i 's/ADDITIONAL_LDFLAGS   = /ADDITIONAL_LDFLAGS   = \nUSER_INCLUDES = \"-I\/usr\/xenomai\/include\"\n/g' Makefile

#CFLAGS   = $(ANSI_OPTS) $(CC_OPTS) $(CPP_REQ_DEFINES) $(INCLUDES)			-->	$(CC_OPTS) $(CPP_REQ_DEFINES) $(INCLUDES)
sed -i 's/CFLAGS   = $(ANSI_OPTS) $(CC_OPTS) $(CPP_REQ_DEFINES) $(INCLUDES)/CFLAGS   = $(CC_OPTS) $(CPP_REQ_DEFINES) $(INCLUDES)/g' Makefile

#CPPFLAGS = $(CPP_ANSI_OPTS) $(CPP_OPTS) $(CC_OPTS) $(CPP_REQ_DEFINES) $(INCLUDES)	-->	$(CPP_OPTS) $(CC_OPTS) $(CPP_REQ_DEFINES) $(INCLUDES)
sed -i 's/CPPFLAGS = $(CPP_ANSI_OPTS) $(CPP_OPTS) $(CC_OPTS) $(CPP_REQ_DEFINES) $(INCLUDES)/CPPFLAGS = $(CPP_OPTS) $(CC_OPTS) $(CPP_REQ_DEFINES) $(INCLUDES)/g' Makefile

#SYSLIBS = $(EXT_LIB) -lm 	-->	SYSLIBS = $(EXT_LIB) -lanalogy -lm -L/usr/xenomai/lib -lxenomai -lrtdm
sed -i 's/SYSLIBS = $(EXT_LIB) -lm/SYSLIBS = $(EXT_LIB) -lanalogy -lm -L\/usr\/xenomai\/lib -lxenomai -lrtdm -lnative/g' Makefile

#USER_SRCS =			-->	USER_SRCS = {.c or .cpp source file name}
sed -i 's/USER_SRCS =/USER_SRCS = ..\/src\/analogy_proxy.c ..\/src\/generic_realtime_simulink_main.c\r\n/g' Makefile

#Enable debugging:
#! this line has been removed from Simon's original code:
#sed -i 's/DEBUG_BUILD          = 0/DEBUG_BUILD          = 1/g' Makefile

#Using our own main routine to control time pulse:
sed -i 's/$(MATLAB_ROOT)\/rtw\/c\/grt\/grt_main.c//g' Makefile
sed -i 's/grt_main.c rt_sim.c/rt_sim.c/g' Makefile

#include...
sed -i 's/\/\* Block signals (auto storage) \*\//#include \"..\/src\/analogy_proxy.h\"\ndouble _stepSize = 0;\n\n\/\* Block signals (auto storage) \*\//g' ${PROJECT_NAME}.c

#include...
sed -i 's/\/\* External inputs (root inport signals with auto storage) \*\//#include \"..\/src\/analogy_proxy.h\"\n\n\/\* External inputs (root inport signals with auto storage) \*\//g' ${PROJECT_NAME}.c

#step size...
#sed -i '/stepSize1 = ([0-9.Ee]*);/a\n_stepSize = \1;' ${PROJECT_NAME}.c

#search/replace de la mort
echo '- Replacing Simulink generated c code with custom AnalogyProxy stuff...'

perl - $PROJECT_NAME <<'__HERE__'
my $PROJECT_NAME = shift;
chdir $PROJECT_NAME . "_grt_rtw";
my $codeFile = $PROJECT_NAME .'.c';

open INPUT, $codeFile or die "Couldn't open file: $!"; 
while (<INPUT>){
 $string .= $_;
}
close INPUT;

$string =~ s/(\S*ToAnalogy) =([^;]*);/$1 =$2;\n  WriteCurrentSampleValueToAnalogy( $1 );/g;
$string =~ s/(\S*.FromAnalogy);/ReadCurrentSampleValueFromAnalogy();/g;
$string =~ s/(\S*.FromAnalogy2);/ReadCurrentSampleValueFromAnalogy2();/g;
$string =~ s/(\S*.FromAnalogy3);/ReadCurrentSampleValueFromAnalogy3();/g;
$string =~ s/(\S*.FromAnalogy4);/ReadCurrentSampleValueFromAnalogy4();/g;

$string =~ s/(\S*stepSize1) = ([^;]*);/$1 =$2;\n  _stepSize = $2;/g;

open (OUTPUT, '>'.$codeFile);
 print OUTPUT $string;
 close (OUTPUT); 
__HERE__

fi

echo '- Building executable...'
echo
make

