% Polynomial excitation function

%! Todo: check the validity of the parameters here. I.e.: is the function
%not hysteretic.... -> Eg: use discriminant...(?) But!: becomes complicated
%for a parameter range..!
%or maybe not too complicated: non hystertic <=> d(q)/dp > -1

%If high near to hysteretic works good -> try to include hysteretic! (see
%commented code below: the else case (?))

%Parameters:

% for zeta: create steped function from zetamin to zetamax
nzeta = 4;
timevs=linspace(0,runtime,nzeta+1);
timevect_sigs = [0, reshape(ones(2,1)*timevs(2:end),1,2*nzeta)];
zeta_min = 0.025;
zeta_max = 0.4;
zeta_vect = [timevect_sigs', [reshape(ones(2,1)*linspace(zeta_min,zeta_max,nzeta),1,2*nzeta), 0.01]'];
%Or cte:
zeta_cte = 0.08;

deltastart = 0;
deltastop = 1;
deltastart_vect = ones(2*nzeta+1,1)*deltastart;
deltastop_vect = ones(2*nzeta+1,1)*deltastop;%!? or: make adapting with zeta..?
deltastart_vect(2:2:end)=0; deltastop_vect(1:2:end)=0;
delta_vect = [timevect_sigs' deltastart_vect+deltastop_vect];
%vb_vect = [timevect_sigs'  vb_min+ (sawtooth(timevect_sigs/5*2*pi)+1)'/2*(vb_max-vb_min) ];
delta_cte = 0.1;

alpha = 100;%!actually a bit like PM...

%Vibrato simulation with variable virtual parallel compliance at the
%instrument input
% Low-pass filter to prevent erroneous feedback:
vibrato.amp = 0.01e-3; %seconds added to the cycle
vibrato.freq = 7; %Hz
fLPcut2 =10000;%[Hz]
hLP2 = fdesign.lowpass('N,F3dB',2,fLPcut2,fs); %! I might try other LP filters with less phase lag... but they're less steep...
HdLP2 = design(hLP2, 'butter');

%test: observe NL excitation curve qdl(pdl):
% p_dlanal = -1:Ts:1;
% q_dlanal=zeta_cte*(-p_dlanal.^3+p_dlanal.^2./delta_cte+p_dlanal);
% 
% p = 3*p_dlanal-1/delta_cte;
% q = 3*p_dlanal.^2-1-2.*p_dlanal/delta_cte+1/zeta_cte;
% r = p_dlanal.^3-p_dlanal.^2/delta_cte-p_dlanal;
% 
% % Old method (BUT: maybe something wrong in that code! + more cumbersome!) 
% % A = (3*q-p.^2)/3;
% % B = (2*p.^3-9*p.*q+27*r)/27;
% % C = A.^3/27 + B.^2/4;
% % sqrtC=sqrt(C);
% % %!! qdltest = (sqrtC-B/2).^(1/3) + (-sqrtC-B/2).^(1/3) - p/3;
% % qdltest = (sqrtC-B/2).^(1/3)  - p/3;
% 
% % New method (from http://math.stackexchange.com/questions/60376/fast-and-robust-root-of-a-cubic-polynomial-with-constraints
% %Mathematica code -> MATLAB... ("arg"->qdl)
% po3 = p/3;
% b = ( po3.^3 - po3.*q/2 + r/2);
% a = (-po3.^2 + q/3);
% deter1 = a.^3 + b.^2;
% %if deter >= 0, %! doesn't work for vectors!
%     deter = (sqrt(deter1) - b).^(1/3);
%     qdltest=-po3 - a./deter + deter;
% % else
% %     % evaluate real part, imaginary parts cancel anyway
% %     absv = sqrt(-a^3);
% %     qdltest = acos(-b/absv);
% %     absv = absv^(1/3);
% %     absv = (absv - a/absv);
% %     qdltest = -po3 + absv*cos(qdltest/3);
% % end
% 
% figure(3),
% plot(p_dlanal,q_dlanal)
% hold on,
% plot(p_dlanal,qdltest,'--r')
% plot(p_dlanal,-p_dlanal,':k')


%Non-hysteretic condition. Check if all this is smaller than 1:
if  zeta_min*(1+4./3*deltastart'.^2)>=1 || ...
    zeta_max*(1+4./3*deltastart'.^2)>=1 || ...
    zeta_min*(1+4./3*deltastop'.^2)>=1 || ...
    zeta_max*(1+4./3*deltastop'.^2)>=1

    warning('The polynomial has been evaluated with parameters that resulted in a hysteretic curve, though the implementation here doesn''t support that!')
    zeta_min*(1+4./3*deltastart'.^2)
    zeta_max*(1+4./3*deltastart'.^2)
    zeta_min*(1+4./3*deltastop'.^2)
    zeta_max*(1+4./3*deltastop'.^2)
end


%Controller info
par1controlmin = zeta_min;
par1controlmax = zeta_max;
par2controlmin = deltastart;
par2controlmax = deltastop;


%% Attack evaluation envelopes
%!timevect_zeta_env1 = [0;0.2;0.21;1.3;1.31]; genvend_time = 1.5;     nenv1 = length(timevect_zeta_env1);
timevect_zeta_env1 = [0;0.2;0.5;1.55;1.56]; genvend_time = 1.9;    nenv1 = length(timevect_zeta_env1);
zeta_maxvect = linspace(0.05,0.4,4);                                nzeta_maxvect = length(zeta_maxvect);
zeta_env = [0.01;0.01;1;1;0.01];                                    nzeta_env = length(zeta_env);
delta_vect_att = linspace(0,0.9,4)';                                ndelta_vect_att = length(delta_vect_att);

%prepare zeta envelopes vector:
n = ndelta_vect_att*nzeta_maxvect;
timevect_zeta_envs_all = [repmat(timevect_zeta_env1,n,1); 0]+ floor(0:1/nenv1:n)'*genvend_time;
n = nzeta_env*nzeta_maxvect;
zeta_envs_all = [timevect_zeta_envs_all, [reshape(reshape(zeta_env * zeta_maxvect, n,1) * ones(1,ndelta_vect_att),ndelta_vect_att*n,1); 0] ];

%prepare delta envelopes vectors:
n=genvend_time*nzeta_maxvect;
timevect_sigs2_delta = [0;n-Ts;n;n*2-Ts;n*2;n*3-Ts;n*3;n*4-Ts;n*4];
delta_envs_all = [timevect_sigs2_delta, [reshape(ones(1,2)' * delta_vect_att' , ndelta_vect_att*2,1) ; 0]];