

/*
 * Include Files
 *
 */
#if defined(MATLAB_MEX_FILE)
#include "tmwtypes.h"
#include "simstruc_types.h"
#else
#include "rtwtypes.h"
#endif

/* %%%-SFUNWIZ_wrapper_includes_Changes_BEGIN --- EDIT HERE TO _END */
#include <math.h>
/* %%%-SFUNWIZ_wrapper_includes_Changes_END --- EDIT HERE TO _BEGIN */
#define u_width 1
#define y_width 1
/*
 * Create external references here.  
 *
 */
/* %%%-SFUNWIZ_wrapper_externs_Changes_BEGIN --- EDIT HERE TO _END */
/* extern double func(double a); */
/*I use this for global variable declarations too!*/
real_T p,q,r;
real_T po3, a, b, deter;
/*
real_T A,B,C;
real_T sqrtC;
*/
/* %%%-SFUNWIZ_wrapper_externs_Changes_END --- EDIT HERE TO _BEGIN */

/*
 * Output functions
 *
 */
void polynomial_excitation_Outputs_wrapper(const real_T *phdl,
			const real_T *zeta,
			const real_T *delta,
			real_T *qdl,
			const real_T *xD)
{
/* %%%-SFUNWIZ_wrapper_Outputs_Changes_BEGIN --- EDIT HERE TO _END */
/* This sample sets the output equal to the input
         y0[0] = u0[0];
For complex signals use: y0[0].re = u0[0].re;
                         y0[0].im = u0[0].im;
                         y1[0].re = u1[0].re;
                         y1[0].im = u1[0].im;*/
p = 3*phdl[0]-2*delta[0];
q = 3*pow(phdl[0],2)-1-4*delta[0]*phdl[0]+1/zeta[0];
r = pow(phdl[0],3)-2*delta[0]*pow(phdl[0],2)-phdl[0];

/* Soluton of the 3rd order eq pdl^3 + p*pdl^2 + q*pdl + r = 0
 * case of 1 real solution only!
 */

/* Using http://math.stackexchange.com/questions/60376/fast-and-robust-root-of-a-cubic-polynomial-with-constraints
 */
po3 = p/3.;
b =  pow(po3,3.) - po3*q/2. + r/2.;
a = -pow(po3,2.) + q/3.;
deter = pow(a,3.) + pow(b,2.);
deter = pow(sqrt(deter) - b,1./3.);
qdl[0]=-po3 - a/deter + deter;

/* Other method (but wrong for some reason! I can't find the original explanation of this! It looks like it's based on Cardano
 *! The error might be in the integer division 1/3 ! this should be 1./3. !!
 *+Note that I changed the role of delta now! (newdelta=2/olddelta)
A = (3*q-pow(p,2))/3;
B = (2*pow(p,3)-9*p*q+27*r)/27;
C = pow(A,3)/27 + pow(B,2)/4;
sqrtC=sqrt(C);
qdl[0] = pow(sqrtC-B/2,1/3) + pow(-sqrtC-B/2,1/3) - p/3;
*/
/* %%%-SFUNWIZ_wrapper_Outputs_Changes_END --- EDIT HERE TO _BEGIN */
}

/*
  * Updates function
  *
  */
void polynomial_excitation_Update_wrapper(const real_T *phdl,
			const real_T *zeta,
			const real_T *delta,
			const real_T *qdl,
			real_T *xD)
{
  /* %%%-SFUNWIZ_wrapper_Update_Changes_BEGIN --- EDIT HERE TO _END */
 
/* %%%-SFUNWIZ_wrapper_Update_Changes_END --- EDIT HERE TO _BEGIN */
}
