% Beating pressure
PM =100; %!set
PM_vect = [[0;30], linspace(10,1000,2)'];
% U0 (/uA)
zeta = 0.35; % typicaly between 0.1 and 0.8
% Nondimensional mouth pressure
gamma_cte = 0.7;

%% Envelopes for sustained sounds.
%For zeta: create sawtooth from 0.1 to 0.6, with 5s period
timevect_sigs = [0,5-Ts,5,10-Ts,10,15-Ts,15,20-Ts,20,25-Ts,25,30-Ts,30];
%minval = 0.1;
%maxval = 0.4;
%zeta_vect = [timevect_sigs'  minval+ (sawtooth(timevect_sigs/5*2*pi)+1)'/2*(maxval-minval) ];
zeta_vect = [timevect_sigs', [0.1;0.1;0.15;0.15;0.2;0.2;0.25;0.25;0.3;0.3;0.35;0.35;0]];
%try: zeta_vect = [timevect_sigs', [0.35;0.35;0.4;0.4;0.45;0.45;0.5;0.5;0.55;0.55;0.6;0.6;0]];
%zeta_vect = [timevect_sigs', [0.4;0.4;0.45;0.45;0.5;0.5;0.55;0.55;0.6;0.6;0.65;0.65;0]];

%gamma_vect = [[0;30], linspace(0.34,1,2)'];
gamma_min = 0.33; gamma_max=2.4;%lipvalve: gamma_min = 1; gamma_max=7;
gamma_vect = [timevect_sigs'  gamma_min+ (sawtooth(timevect_sigs/5*2*pi)+1)'/2*(gamma_max-gamma_min) ];

%! used later:
timevect_sigs = [0,5-Ts,5,10-Ts,10,15-Ts,15];
zeta_vect = [timevect_sigs', [0.1;0.1;0.2;0.2;0.3;0.3;0]];
gamma_min = 0; gamma_max=2.8;%lipvalve: gamma_min = 1; gamma_max=7;
gamma_vect = [timevect_sigs'  gamma_min+ (sawtooth(timevect_sigs/5*2*pi)+1)'/2*(gamma_max-gamma_min) ];


%for the controller:
par1controlmin = gamma_min; par1controlmax=gamma_max;
par2controlmin = zeta_vect(1,2); par2controlmax = 0.5;%!zeta_vect(end-1,2);

%% Gamma and zeta envelopes for the attack measurements
%Note: attack evaluation cannot be made relative from runtime, because the
%attack envelope times have to be respected!
%timevect_gamma_env1 = [0;0.2;0.5;1.55;1.56]; genvend_time = 1.9;	nenv1 = length(timevect_gamma_env1);
timevect_gamma_env1 = [0;0.2;0.21;1.3;1.31]; genvend_time = 1.5;	nenv1 = length(timevect_gamma_env1);
genvend_time = 1.5;
gamma_mavvect = [0.4 0.45 0.5 0.6 0.7 0.8 0.9 1 1.1 1.2];           ngamma_mavvect = length(gamma_mavvect);
gamma_env1_a = [0;0;1;1;0];                                         ngamma_env1_a = length(gamma_env1_a);
zeta_vect2a = [0.1;0.15;0.2];                                       nzeta_vect2a = length(zeta_vect2a);
zeta_vect2b = [0.25;0.3;0.35];

%prepare gamma envelopes vector:
n = nzeta_vect2a*ngamma_mavvect;
timevect_gamma_envs_all = [repmat(timevect_gamma_env1,n,1); 0]+ floor(0:1/nenv1:n)'*genvend_time;
n = ngamma_env1_a*ngamma_mavvect;
gamma_envs_all = [timevect_gamma_envs_all, [reshape(reshape(gamma_env1_a * gamma_mavvect, n,1) * ones(1,nzeta_vect2a),nzeta_vect2a*n,1); 0] ];

%prepare zeta envelopes vectors:
n=genvend_time*ngamma_mavvect;
timevect_sigs2_zeta = [0;n-Ts;n;n*2-Ts;n*2;n*3-Ts;n*3];
zeta_envs_all_a = [timevect_sigs2_zeta, [reshape(ones(1,2)' * zeta_vect2a' , nzeta_vect2a*2,1) ; 0]];
zeta_envs_all_b = [timevect_sigs2_zeta, [reshape(ones(1,2)' * zeta_vect2b' , nzeta_vect2a*2,1) ; 0]];


%% Reed dynamics
wr = 2*pi*2500;%-> note: no big difference on descriptors, if 2500 or 10000!
Qr=5; %!! during some test with pt2  it squeeqed on this freq, no other sound appeared. when Qr was set to 1, no sound at all...
qr=1/Qr;
reeddir=-1;%The - sign is to set the correct direction of the reed movement.

%approximated digitized version (Guillemain2005)
a0a = fs^2/wr^2 + fs*qr/(2*wr);
b1a = 1/a0a;
a1a = (2*fs^2/wr^2 -1)/a0a;
a2a = (fs*qr/(2*wr) - fs^2/wr^2)/a0a;
 %note that the succeeding zero's in the numerator vectors are required for Matlab's "tf" and only optional for the Simulink "transfer function"
%!! before version tracking on xeno pc, reeddir was not used and no - sign before b1a!! => is the implementation of the filter different in the hybrid mdl!?
HRreed_G.num = [0, reeddir*b1a, 0];
HRreed_G.den = [1, -a1a, -a2a];
HRreed_G_zm1.num = [reeddir*b1a, 0, 0]; % As the pressure measurement occurs 1 sample too late, we erase the 1 sample delay from the reed-complicance-filter.
